;ESTE PROGRAMA FOI COMPILADO NO MAKENSISW 2.0
;OBJETIVOS:
	;1. INSTALAR AS SEGUINTES EXTENSES QUE FICARO DISPONVEIS PARA O USURIO QUE LOGOU NA ESTAO
		;- VERIFICADOR ORTOGRFICO
		;- MODELOS DE DOCUMENTOS BB
		;- DICIONRIO DE SINNIMOS
		;- BB MENU
		;- BB FORMULRIOS
		;- ETIQUETAS PIMACO
		;- DESENHOS PIMACO
		;- MODELOS PIMACO
	;2. FAZ O LOAD DOS DICIONRIOS INSTALADOS
	;3. REMOVE O VERIFICADOR GRAMATICAL COGROO DEVIDO A PROBLEMAS DE INCOMPATIBILIDADES COM A JVM
;CARACTERSTICAS DO INSTALADOR: INSTALAO FORADA DESASSISTIDA
;AUTOR: KRAUCER FERNANDES MAZUCO (20/07/2009) - GETEC 35

;TIPO DE INSTALAO: INSTALAO FORADA DESASSISTIDA

;TAREFAS PENDENTES
;1. COMANDO PARA DESINSTALAR O COGROO - OK
;2. INSTALAR DICIONRIO DE SINNIMOS - OK
;3. ATUALIZAR VERO - OK
;4. INSTALAR BB MENU - OK, APENAS TESTAR
;5. INSTALAR BB FORMULRIOS WEB, OK APENAS TESTAR
;6. CONTROLAR NOVA VERSO DE PERSONALIZAO, OK APENAS TESTAR
;7. INSTALAR PIMACO ETIQUETAS, LABELS, DRAW, OK APENAS TESTAR

Name "Personalizador do BrOffice.org"
OutFile "bro-personal.exe"
!include "FileFunc.nsh"
!include "LogicLib.nsh"
!include "WinMessages.nsh"
RequestExecutionLevel user ;apenas para o Windows Vista + UAC
ShowInstDetails Nevershow
Var LOCALDATA
Var USERNAME
Var SISOP

Function .onInit
		SetSilent Silent
FunctionEnd

Section "Incio"
		;IREI LER O SISTEMA OPERACIONAL DEVIDO A ALGUMAS ESPECIFICIDADES ENTRE XP E VISTA
		ReadRegStr $SISOP HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" ProductName
		
		;BUSCO O NOME DO USURIO LOGADO NO MOMENTO DA INSTALAO
		UserInfo::GetName
		Pop $USERNAME
		
		;POR NO CONSEGUIR TRATAR CORRETAMENTE A CONSTANTE $LOCALAPPDATA, IREI VERIFIC-LA CONFORME O SISTEMA OPERACIONAL
		ReadRegStr $SISOP HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" ProductName
		StrCpy $LOCALDATA "C:\Documents and Settings\$USERNAME\dados de aplicativos"
		${If} $SISOP == 'Microsoft Windows XP'
			StrCpy $LOCALDATA "C:\Documents and Settings\$USERNAME\dados de aplicativos"
		${ElseIf} $SISOP == 'Windows Vista (TM) Business'
			StrCpy $LOCALDATA "C:\Users\$USERNAME\AppData\Roaming"
		${EndIf}
		
		;O CONTROLE DA EXISTNCIA OU NO DAS PERSONALIZAES DO BROFFICE.ORG NO EST MAIS NO LOGIN SCRIPT. POR ESSE MOTIVO, IREI VERIFICAR AGORA SUA
		;EXISTNCIA. CASO AS PERSONALIZAES J EXISTIREM,  NO IREI EXECUTAR.
		IfFileExists "$LOCALDATA\BrOffice.org\3\user\registry\data\personal-082009.txt" 0 +2
			Quit
			
		;INSTALAES PERSONALIZADAS E EXCLUSIVAS PARA O WINDOWS XP (VISTA NO PERMITE DEVIDO AO CONTROLE DO UAC)
		;INSTALANDO A EXTENSO DO VERIFICADOR ORTOGRFICO
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\Vero_pt_BR_V205AOC.oxt"

		;DESINSTALA A EXTENSO DO CORRETOR GRAMATICAL COGROO
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe remove br.usp.pcs.lta.cogroo.ooointegration.oxt"

		;INSTALANDO A EXTENSO DO MODELO DE DOCUMENTOS
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\Modelos_BrOffice-BB-v01.oxt"			

		;INSTALANDO A EXTENSO QUE POSSIBILITA A IMPORTAO DE ARQUIVOS PDF NO DRAW
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\pdfimport.oxt"
		
		;INSTALANDO A EXTENSO PIMACO (ETIQUETAS, GABARITOS E MODELOS)
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\pimaco-labels.oxt"
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\pimaco-drawings.oxt"
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\pimaco-templates.oxt"
		
		;INSTALANDO A EXTENSO DICIONRIO DE SINNIMOS
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\DicSin-BR.oxt"
		
		;INSTALANDO A EXTENSO BB MENU
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\BB_menu.oxt"
		
		;INSTALANDO A EXTENSO BB FORMULRIOS
		ExecWait "$PROGRAMFILES\BrOffice.org 3\program\unopkg.exe add C:\BrOffice-v30\Extenses\BB_formularios.oxt"
		
		;INSTALANDO DICIONRIOS TEMTICOS DE INFORMTICA E JURDICO APENAS PARA O USURIO QUE INSTALOU O BROFFICE.ORG POIS NO
		;CONSIGO ESCREVER NO C:\PROGRAM FILES DO VISTA DEVIDO AO UAC
		IfFileExists "$LOCALDATA\BrOffice.org\3\user\wordbook\DicInfo.dic" +6 0
			SetOverwrite on
			SetOutPath "$LOCALDATA\BrOffice.org\3\user\wordbook"
			File "C:\BrOffice-v30\dict\DicInfo.dic"
			File "C:\BrOffice-v30\dict\DicInfo2.dic"
			File "C:\BrOffice-v30\dict\DicInfo3.dic"
			File "C:\BrOffice-v30\dict\DicJuridico.dic"
		
		;SE O ARQUIVO SETUP.XCU NO EXISTIR NO PROFILE DO USURIO, FAREI A CPIA PARA EVITAR TELA DE ERRO NA INICIALIZAO
		IfFileExists "$LOCALDATA\BrOffice.org\3\user\registry\data\org\openoffice\Setup.xcu" +3 0
			SetOverwrite on
			SetOutPath "$LOCALDATA\BrOffice.org\3\user\registry\data\org\openoffice"
			File "C:\BrOffice-v30\register\Setup.xcu"
		
		;SE O ARQUIVO COMMON.XCU NO EXISTIR NO PROFILE DO USURIO, FAREI A CPIA PARA EVITAR TELA DE ERRO NA INICIALIZAO
		IfFileExists "$LOCALDATA\BrOffice.org\3\user\registry\data\org\openoffice\Office\Common.xcu" +3 0
			SetOverwrite on
			SetOutPath "$LOCALDATA\BrOffice.org\3\user\registry\data\org\openoffice\Office"
			File "C:\BrOffice-v30\register\Common.xcu"
		
		;SE O ARQUIVO  SCRIPT.XLC NO EXISTIR NO PROFILE DO USURIO, FAREI A CPIA PARA EVITAR TELA DE ERRO NA INICIALIZAO
		IfFileExists "$LOCALDATA\BrOffice.org\3\user\basic\script.xlc" +8 0
			SetOverwrite on
			SetOutPath "$LOCALDATA\BrOffice.org\3\user\basic"
			File "C:\BrOffice-v30\register\script.xlc"
			File "C:\BrOffice-v30\register\dialog.xlc"
			SetOutPath "$LOCALDATA\BrOffice.org\3\user\basic\Standard"
			File "C:\BrOffice-v30\register\script.xlb"
			File "C:\BrOffice-v30\register\dialog.xlb"
			File "C:\BrOffice-v30\register\Module1.xba"
			
		;ATIVA O LOAD DE TODOS OS DICIONRIOS IMPLANTADOS
		SetOverwrite on
		SetOutPath "$LOCALDATA\BrOffice.org\3\user\registry\data\org\openoffice\Office"
		File "C:\BrOffice-v30\dict\Linguistic.xcu"
		
		;FAREI UMA CPIA DO ARQUIVO PERSONAL-082009.TXT SINALIZANDO QUE A PERSONALIZAO DO BROFFICE FOI APLICADA COM SUCESSO, EVITANDO
		;DESTA FORMA UMA NOVA APLICAO DESNECESSRIA 
		SetOverwrite on
		SetOutPath "$LOCALDATA\BrOffice.org\3\user\registry\data"
		File "C:\BrOffice-v30\personal\personal-082009.txt"
		Quit
SectionEnd